# Global directory definitions
%global system_datadir %{_var}/lib/%{name}/storage
%global system_cachedir %{_var}/cache/%{name}/osgi-cache
%global system_logdir %{_var}/log/%{name}
%global system_statedir %{_localstatedir}/run/%{name}
# Uncomment to build from snapshot out of hg.  See also Release and Source0
#%global hgrev 97e66ed2e4ae

Name:       thermostat
Version:    0.9.2
# If building from snapshot out of hg, uncomment and adjust below value as appropriate
#Release:    0.1.20130521hg%{hgrev}%{?dist}
Release:    3%{?dist}
Summary:    A monitoring and serviceability tool for OpenJDK
License:    GPLv2+ with exceptions
URL:        http://icedtea.classpath.org/thermostat/
# This is the source URL to be used for released versions
Source0:    http://icedtea.classpath.org/download/%{name}/%{name}-%{version}.tar.gz
# This is the source to be used for hg snapshot versions
#wget -O thermostat-%{hgrev}.tar.bz2 http://icedtea.classpath.org/hg/%{name}/archive/%{hgrev}.tar.bz2
#Source0:    thermostat-%{hgrev}.tar.bz2
# This is _NOT_ suitable for upstream at this point.
# It's very Fedora specific.
Source1:    thermostat-sysconfig
Source2:    thermostat_icon_64px.svg
# FIXME: This has been fixed upstream with rev 9c20c3b08192.
#        Should get removed next release.
Patch0:     init_layout_new.patch
# This is _NOT_ suitable for upstream at this point.
# It makes thermostat work with system (non-writable) installations.
Patch1:     source_setup_user_home.patch
# FIXME: This has been fixed upstream with rev 9c1ebac8d0b9.
#        Should get removed next release.
Patch2:     username_util.patch
# FIXME: This has been fixed upstream with rev edb423d5d5a0.
#        Should get removed next release.
Patch3:     fix_natives.patch
# This is _NOT_ suitable for upstream at this point.
# jfreechart isn't a bundle upstream. Also some httpclient* related bundles
# include transitive deps upstream, which isn't the case in Fedora (i.e. is
# properly done in Fedora)
Patch4:     fix_bundle_loading.patch
# There seems to be a problem when using class vs. class name
# (i.e. Klass.class vs. Klass.class.getName()).
# Proposed upstream. Unsure if something like this will be required for next
# release.
Patch5:     fix_jmx_compilation_error.patch
# FIXME: This has been fixed upstream with rev c6ad4123876e.
#        Should get removed next release.
Patch6:     extend_webservice_fix.patch
# This is _NOT_ suitable for upstream at this point.
# Sets the default log level to something reasonable (if during release procedure
# it was forgotten to set it). Not upstream-able.
Patch7:     fix_loglevel.patch
# FIXME: This has been fixed upstream with rev cffa49e21080.
#        Should get removed next release.
Patch8:     systemd_fixes.patch

BuildRequires:  java-devel >= 1:1.7.0
BuildRequires:  jpackage-utils

BuildRequires: maven-local
# Explicitly require xmvn >= 0.4.2-1.1 Otherwise
# config for skipping installation of the war module will not work.
# See RHBZ#963838
BuildRequires: xmvn >= 0.4.2-1.1
BuildRequires: maven-dependency-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: maven-surefire-provider-junit4
BuildRequires: maven-war-plugin
BuildRequires: maven-clean-plugin
BuildRequires: maven-assembly-plugin
BuildRequires: maven-plugin-bundle
BuildRequires: maven-javadoc-plugin

BuildRequires: libgnome-keyring-devel
BuildRequires: felix-framework
BuildRequires: fusesource-pom
BuildRequires: jansi
# laf-utils JNI need pkconfig files for gtk2+
BuildRequires: gtk2-devel
# 1.0.14-7 has OSGi metadata and itext dep fix
BuildRequires: jfreechart >= 1.0.14-7
# 1.0.17-4 has OSGi metadata
BuildRequires: jcommon >= 1.0.17-4
BuildRequires: apache-commons-logging
BuildRequires: apache-commons-beanutils
BuildRequires: apache-commons-cli
BuildRequires: apache-commons-codec
BuildRequires: jline2 >= 2.5-7
BuildRequires: mongo-java-driver
BuildRequires: mongo-java-driver-bson
BuildRequires: netty
# lucene 3.6.0-6 has fixed osgi metadata
BuildRequires: lucene >= 3.6.0-6
# Use tomcat only for web storage
BuildRequires: tomcat-servlet-3.0-api
BuildRequires: google-gson
BuildRequires: apache-commons-fileupload
BuildRequires: httpcomponents-core
BuildRequires: httpcomponents-client

Requires: java >= 1:1.7.0
Requires: jpackage-utils

Requires: felix-framework
Requires: jansi
Requires: java-devel >= 1:1.7.0
# jline2 2.5-7 has jansi-internal import-package fix.
Requires: jline2 >= 2.5-7
# 1.0.14-3 has OSGi metadata (itext fix is for BR only,
# since it was only maven complaining about missing dep)
Requires: jfreechart >= 1.0.14-3
# 1.0.17-4 has OSGi metadata
Requires: jcommon >= 1.0.17-4
Requires: mongodb
Requires: mongodb-server
Requires: mongo-java-driver
Requires: mongo-java-driver-bson
Requires: netty
# lucene 3.6.0-6 has fixed osgi metadata
Requires: lucene >= 3.6.0-6
Requires: libgnome-keyring
Requires: apache-commons-logging
Requires: apache-commons-beanutils
Requires: apache-commons-cli
Requires: apache-commons-codec
Requires: google-gson
Requires: apache-commons-fileupload
Requires: httpcomponents-core
Requires: httpcomponents-client
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
# At this point some of the icons in thermostat are hard-coded to
# gnome icons. This is going to change upstream. Once that's done
# (self-contained within thermostat) we can remove this again.
# See RHBZ#966892
Requires: gnome-icon-theme

%description
Thermostat is a monitoring and instrumentation tool for the Hotspot JVM,
with support for monitoring multiple JVM instances. The system is made
up of two processes: an Agent, which collects data, and a Client which
allows users to visualize this data. These components communicate via
a MongoDB-based storage layer. A pluggable agent framework allows for
collection of performance data beyond that which is included out of the
box. Support for corresponding pluggable GUI components for visualization
of additional data is pending.

%package javadoc
Summary:    Javadocs for %{name}
Group:      Documentation
Requires:   jpackage-utils

BuildArch:  noarch

%description javadoc
This package contains the API documentation for %{name}

%package webapp
Summary:    Web storage for Thermostat
Requires:   tomcat
Requires:   tomcat-servlet-3.0-api
Requires:   %{name} = %{version}

%description webapp
This package contains the exploded web archive which installs into
tomcat's webapps directory.

%prep
#%setup -q -n %{name}-%{hgrev}
%setup -q -n %{name}-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

# webservice command is going to be disabled.
rm distribution/config/commands/webservice.properties
%pom_disable_module cmd web

# Fix up artifact names which have different name upstream
#  lucene
%pom_remove_dep "org.apache.servicemix.bundles:org.apache.servicemix.bundles.lucene" common/core
%pom_add_dep "org.apache.lucene:lucene-core:3.6.0" common/core
#  commons-logging
%pom_remove_dep org.apache.commons:com.springsource.org.apache.commons.logging storage/mongo
%pom_add_dep commons-logging:commons-logging:1.1.1 storage/mongo
#  httpclient
%pom_remove_dep org.apache.httpcomponents:httpclient-osgi web/client
%pom_add_dep org.apache.httpcomponents:httpclient:4.1.2 web/client
%pom_remove_dep org.apache.httpcomponents:httpclient-osgi client/command
%pom_add_dep org.apache.httpcomponents:httpclient:4.1.2 client/command
#  add httpmime dep. this is included in upstreams' strange jar
%pom_add_dep org.apache.httpcomponents:httpmime:4.1.2 web/client
#  httpcore
%pom_remove_dep org.apache.httpcomponents:httpcore-osgi web/client
%pom_add_dep org.apache.httpcomponents:httpcore:4.1.2 web/client
# need jline 2.10 (otherwise this resolves to jline 1)
%pom_xpath_remove "pom:properties/pom:jline.version"
%pom_xpath_inject "pom:properties" "<jline.version>2.10</jline.version>"

# Don't use maven-exec-plugin. We do things manually in order to avoid this
# additional dep. It's used in agent/core/pom.xml and in keyring/pom.xml
%pom_remove_plugin org.codehaus.mojo:exec-maven-plugin agent/core
%pom_remove_plugin org.codehaus.mojo:exec-maven-plugin keyring
%pom_remove_plugin org.codehaus.mojo:exec-maven-plugin laf-utils

# Remove jacoco-coverage plugin (in main pom.xml and web/war/pom.xml)
%pom_remove_plugin org.jacoco:jacoco-maven-plugin
%pom_remove_plugin org.jacoco:jacoco-maven-plugin web/war

# Remove pmd plugin
%pom_remove_plugin org.apache.maven.plugins:maven-pmd-plugin

# Remove m2e's lifecyle plugin
%pom_remove_plugin org.eclipse.m2e:lifecycle-mapping

# Disable dev and integation-tests modules
%pom_disable_module dev
%pom_disable_module integration-tests

# Part of the disable webservice patch can be done with pom macros
%pom_remove_dep com.redhat.thermostat:thermostat-web-cmd distribution
%pom_remove_dep org.eclipse.jetty:jetty-server distribution
%pom_remove_dep org.eclipse.jetty:jetty-webapp distribution

# Skip automatic installation of the war module.
# We install it manually. Without this "config" %mvn_build -f
# fails. See RHBZ#963838
%mvn_package :thermostat-web-war __noinstall
# Don't install :thermostat-common-test, it's a test only dep which
# aren't run during the build.
%mvn_package :thermostat-common-test __noinstall

# These are just upstream build helpers. Don't install them.
%mvn_package :thermostat-distribution __noinstall
%mvn_package :thermostat-assembly __noinstall

# thermostat-web-server should be part of the webapp sub-package
%mvn_package :thermostat-web-server webapp

%build
export CFLAGS="$RPM_OPT_FLAGS" LDFLAGS="$RPM_LD_FLAGS"
# Set JAVA_HOME. make uses this
. /usr/share/java-utils/java-functions
set_jvm
export JAVA_HOME

################## Build JNI bits ########################
pushd keyring
mkdir -p target/classes
javac -d target/classes src/main/java/com/redhat/thermostat/utils/keyring/Keyring.java \
         src/main/java/com/redhat/thermostat/utils/keyring/Credentials.java \
         src/main/java/com/redhat/thermostat/utils/keyring/GnomeKeyringLibraryNative.java \
         ../annotations/src/main/java/com/redhat/thermostat/annotations/Service.java
make all
rm target/classes/com/redhat/thermostat/annotations/Service.class
popd
pushd agent/core
mkdir -p target/classes
javac -d target/classes \
         src/main/java/com/redhat/thermostat/utils/hostname/HostName.java \
         src/main/java/com/redhat/thermostat/utils/username/UserNameUtil.java \
         src/main/java/com/redhat/thermostat/utils/username/internal/UserNameUtilImpl.java
make all
popd
pushd laf-utils
mkdir -p target/classes
javac -d target/classes src/main/java/com/redhat/thermostat/internal/utils/laf/gtk/GTKThemeUtils.java
make all
popd
################## Build JNI bits (end) ##################

# This is roughly equivalent to:
#   mvn 
#     -Dthermostat.home=%{_datarootdir}/%{name} \
#     -Dthermostat.web.deploy.dir=$(pwd)/webstorage-webapp \
#    install javadoc:aggregate
# Everything after '--' is passed to plain xmvn/mvn
%mvn_build -f -- -Dthermostat.home=%{_datarootdir}/%{name} \
                 -Dthermostat.web.deploy.dir=$(pwd)/webstorage-webapp \
                 -Dthermostat.system.user=thermostat \
                 -Dthermostat.system.group=thermostat

# the build puts all depdency jars into distribution/target/lib as well
mv distribution/target/libs/thermostat-*jar .
rm -f distribution/target/libs/*jar
mv thermostat-*jar distribution/target/libs/

# fix path to java in scripts
sed -i 's|^JAVA=.*|JAVA="/usr/lib/jvm/java-openjdk/jre/bin/java"|' distribution/target/bin/thermostat

# Remove dirs/files which we don't need shipped
rm -rf distribution/target/{antrun,archive-tmp,maven-archiver,maven-status,osgi-cache,generated-sources,tools,classes}
rm distribution/target/thermostat-distribution-*.jar

# Collect a list of filenames which we later use in order to symlink from /usr/share/java
pushd distribution/target/libs
for i in *.jar; do
  newFileName=$(echo $i | sed 's/-\([0-9]\+\.\)\+[0-9]\+\(-[a-zA-Z0-9]\+\)\?//')
  # collect original filenames in a file so that we can symlink to them
  # from %{_javadir}/%{name}
  echo "libs/${i}#${newFileName}" >> ../../symlink-map-filenames
done
popd
pushd distribution/target/plugins
for i in $(find -name '*.jar' | sed 's#^./##g'); do
  fname=$(basename $i)
  newFileName=$(echo $fname | sed 's/-\([0-9]\+\.\)\+[0-9]\+\(-[a-zA-Z0-9]\+\)\?//')
  echo "plugins/${i}#${newFileName}" >> ../../symlink-map-filenames
done
popd
grep -v "thermostat-web-server" distribution/symlink-map-filenames > distribution/symlink-map-filenames-filtered
mv distribution/symlink-map-filenames-filtered distribution/symlink-map-filenames

# clean-up webapp. these are all symlinks to libs in /usr/share/thermostat
# except for thermostat-web-server
pushd webstorage-webapp
rm -rf WEB-INF/lib/*
popd
mv distribution/target/libs/thermostat-web-server*.jar webstorage-webapp/WEB-INF/lib

%install
#######################################################
# Thermostat core
#######################################################
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sysconfdir}/%{name}
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
mkdir -p %{buildroot}%{_datarootdir}
# JNI things live there
mkdir -p %{buildroot}%{_libdir}/%{name}
mkdir -p %{buildroot}%{_jnidir}
# Systemd files live there
mkdir -p %{buildroot}%{_unitdir}
# Thermostat icon lives there
mkdir -p %{buildroot}%{_datarootdir}/icons/hicolor/scalable/apps
# Thermostat desktop lives there
mkdir -p %{buildroot}%{_datarootdir}/applications

# Dance the xmvn install limbo. This only makes sense if %mvn_build does NOT
# have the '-i' switch.
%mvn_install

rm -rf %{buildroot}%{_javadir}/%{name}

# now make xmvn happy, it expects version-less thermostat jars in
# %{_javadir}/%{name}
mkdir %{buildroot}%{_javadir}/%{name}
for i in $(cat distribution/symlink-map-filenames); do
  s=$(echo $i | cut -d'#' -f1)
  t=$(echo $i | cut -d'#' -f2)
  ln -s %{_datarootdir}/%{name}/$s %{buildroot}%{_javadir}/%{name}/$t
done

pushd distribution/target/libs
# JNI jars need to be in %{_jnidir}, we symlink to
# %{_libdir}/%{name} files. Files are moved to
# %{_libdir}/%{name} next.
for i in thermostat-keyring-*.jar \
    thermostat-agent-core-*.jar \
    thermostat-laf-utils-*.jar; do
  ln -s %{_libdir}/%{name}/$i %{buildroot}%{_jnidir}/$i
done
# JNI files are in %{_libdir}
mv thermostat-keyring-*.jar \
   thermostat-agent-core-*.jar \
   thermostat-laf-utils-*.jar \
   %{buildroot}%{_libdir}/%{name}
# Make native libs executable so that debuginfos get properly
# generated
chmod +x native/*.so
mv native/* %{buildroot}%{_libdir}/%{name}
popd

# Install systemd unit files
pushd distribution/target/systemd
sed -i 's/User=thermostat/User=root/g' thermostat-agent.service
sed -i 's/Group=thermostat/Group=root/g' thermostat-agent.service
cp -a *.service %{buildroot}%{_unitdir}/
popd
rm -rf distribution/target/systemd

# Remove agent/storage directories which get symlinked later
rm -r distribution/target/storage/{db,run,logs}
rm -r distribution/target/agent/{run,logs}

# Move the thermostat desktop file to /usr/share/applications
# This makes "thermostat gui" show up in gnome shell.
cp distribution/target/%{name}.desktop %{buildroot}%{_datarootdir}/applications/%{name}.desktop
# Install the SVG icon
cp %{SOURCE2} %{buildroot}%{_datarootdir}/icons/hicolor/scalable/apps/%{name}.svg

# move everything else into /usr/share/thermostat
cp -a distribution/target %{buildroot}%{_datarootdir}/%{name}

# symlink dependencies into the right directory
ln -s %{_javadir}/felix/org.apache.felix.framework.jar %{buildroot}%{_datarootdir}/%{name}/libs/org.apache.felix.framework.jar
ln -s %{_javadir}/hawtjni-runtime.jar %{buildroot}%{_datarootdir}/%{name}/libs/hawtjni-runtime.jar
# the following required symlinks and their name can be looked up in
# distribution/pom.xml (version-less-dep-symlinks)
# these symlinks are required as these dependency jars are started via the embedded OSGi
# framework
ln -s %{_javadir}/jfreechart/jfreechart.jar %{buildroot}%{_datarootdir}/%{name}/libs/jfreechart.jar
ln -s %{_javadir}/httpcomponents/httpcore.jar %{buildroot}%{_datarootdir}/%{name}/libs/httpcomponents-core.jar
ln -s %{_javadir}/httpcomponents/httpclient.jar %{buildroot}%{_datarootdir}/%{name}/libs/httpcomponents-client.jar
ln -s %{_javadir}/apache-commons-cli.jar %{buildroot}%{_datarootdir}/%{name}/libs/commons-cli.jar
ln -s %{_javadir}/apache-commons-collections.jar %{buildroot}%{_datarootdir}/%{name}/libs/commons-collections.jar
ln -s %{_javadir}/apache-commons-beanutils.jar %{buildroot}%{_datarootdir}/%{name}/libs/commons-beanutils.jar
ln -s %{_javadir}/apache-commons-logging.jar %{buildroot}%{_datarootdir}/%{name}/libs/commons-logging.jar
ln -s %{_javadir}/apache-commons-io.jar %{buildroot}%{_datarootdir}/%{name}/libs/commons-io.jar
ln -s %{_javadir}/apache-commons-fileupload.jar %{buildroot}%{_datarootdir}/%{name}/libs/commons-fileupload.jar
ln -s %{_javadir}/jcommon.jar %{buildroot}%{_datarootdir}/%{name}/libs/jcommon.jar
ln -s %{_javadir}/jline2.jar %{buildroot}%{_datarootdir}/%{name}/libs/jline2.jar
ln -s %{_javadir}/lucene.jar %{buildroot}%{_datarootdir}/%{name}/libs/lucene.jar
ln -s %{_javadir}/netty.jar %{buildroot}%{_datarootdir}/%{name}/libs/netty.jar
ln -s %{_javadir}/mongo.jar %{buildroot}%{_datarootdir}/%{name}/libs/mongo.jar
ln -s %{_javadir}/google-gson.jar %{buildroot}%{_datarootdir}/%{name}/libs/gson.jar
ln -s %{_javadir}/tomcat-servlet-api.jar %{buildroot}%{_datarootdir}/%{name}/libs/javax-servlet.jar
# The following are additional Fedora specific symlinks for transitive deps
#   see fix_bundle_loading.patch
# some of them have their deps embedded upstream (or whatever is available in the maven repos)
#
# jline2 => jansi
# httpclient => httpmime
# httpclient => commons-codec
ln -s %{_javadir}/jansi.jar %{buildroot}%{_datarootdir}/%{name}/libs/jansi.jar
ln -s %{_javadir}/httpcomponents/httpmime.jar %{buildroot}%{_datarootdir}/%{name}/libs/httpcomponents-mime.jar
ln -s %{_javadir}/apache-commons-codec.jar %{buildroot}%{_datarootdir}/%{name}/libs/commons-codec.jar

pushd %{buildroot}%{_libdir}/%{name}
# symlink JNI jars
for i in *.jar; do
  ln -s %{_libdir}/%{name}/$i \
        %{buildroot}%{_datarootdir}/%{name}/libs/$i
done
# symlink shared libs
for i in *.so; do
  ln -s %{_libdir}/%{name}/$i \
        %{buildroot}%{_datarootdir}/%{name}/libs/native/$i
done
popd

ln -s /usr/lib/jvm/java-openjdk/lib/tools.jar \
    %{buildroot}%{_datarootdir}/%{name}/libs/

# Symlink the thermostat script in /bin
ln -s %{_datarootdir}/%{name}/bin/thermostat \
    %{buildroot}%{_bindir}/thermostat

# move config files to /etc/ and symlink stuff under /usr/share/thermostat to it
mv %{buildroot}%{_datarootdir}/%{name}/agent/agent.properties \
    %{buildroot}%{_sysconfdir}/%{name}/agent.properties
ln -s %{_sysconfdir}/%{name}/agent.properties \
    %{buildroot}%{_datarootdir}/%{name}/agent/agent.properties
mv %{buildroot}%{_datarootdir}/%{name}/storage/db.properties \
    %{buildroot}%{_sysconfdir}/%{name}/db.properties
ln -s %{_sysconfdir}/%{name}/db.properties \
    %{buildroot}%{_datarootdir}/%{name}/storage/db.properties
pushd %{buildroot}%{_datarootdir}/%{name}/etc
for i in $(ls); do
mv %{buildroot}%{_datarootdir}/%{name}/etc/$i \
    %{buildroot}%{_sysconfdir}/%{name}/$i
ln -s %{_sysconfdir}/%{name}/$i \
    %{buildroot}%{_datarootdir}/%{name}/etc/$i
done
popd

# Install sysconfig file. This is so as to set THERMOSTAT_HOME to
# /usr/share/thermostat rather than ~/.thermostat which the script
# would do.
sed -i 's#__installdir__#%{_datarootdir}/%{name}/#g' %{SOURCE1}
cp %{SOURCE1} %{buildroot}%{_sysconfdir}/sysconfig/%{name}

# Set up directory structure for running thermostat storage/
# thermostat agend via systemd
%{__install} -d -m 0775 %{buildroot}%{system_datadir}/db
%{__install} -d -m 0775 %{buildroot}%{system_cachedir}
%{__install} -d -m 0775 %{buildroot}%{system_logdir}/storage
%{__install} -d -m 0775 %{buildroot}%{system_statedir}/storage
%{__install} -d -m 0775 %{buildroot}%{system_statedir}/agent
# Symlink storage/agent directories so that they can be run
# as systemd services. The target directories will have
# appropriate permissions for the thermostat user to allow
# writing.
ln -s %{system_datadir}/db %{buildroot}%{_datarootdir}/%{name}/storage/db
ln -s %{system_statedir}/storage %{buildroot}%{_datarootdir}/%{name}/storage/run
ln -s %{system_logdir}/storage %{buildroot}%{_datarootdir}/%{name}/storage/logs
ln -s %{system_statedir}/agent %{buildroot}%{_datarootdir}/%{name}/agent/run
ln -s %{system_cachedir} %{buildroot}%{_datarootdir}/%{name}/osgi-cache

#######################################################
# Thermostat web storage webapp
#######################################################
mkdir -p %{buildroot}%{_datadir}/tomcat/webapps
pushd webstorage-webapp
# Fixup THERMOSTAT_HOME in web.xml
sed -i '/<param-name>THERMOSTAT_HOME<[/]param-name>/,/<param-value>.*<[/]param-value>/{ s$<param-value>.*</param-value>$<param-value>%{_datadir}/%{name}</param-value>$ }' \
 WEB-INF/web.xml
# Fixup 'pathname' to thermostat-users.xml file in context.xml
sed -i '/Realm className="org.apache.catalina.realm.MemoryRealm"/,/pathname=".*"/{ s|pathname=".*\(WEB-INF/thermostat-users.xml\)"|pathname="%{_datadir}/tomcat/webapps/%{name}/\1"| }' \
 META-INF/context.xml
popd
cp -r webstorage-webapp %{buildroot}%{_datadir}/tomcat/webapps/%{name}

# Make xmvn happy. Give it a symlink in %{_javadir}/%{name}
pushd %{buildroot}%{_datadir}/tomcat/webapps/%{name}/WEB-INF/lib
for i in thermostat-*.jar; do
  newFileName=$(echo $i | sed 's/-\([0-9]\+\.\)\+[0-9]\+\(-[a-zA-Z0-9]\+\)\?//')
  ln -s %{_datadir}/tomcat/webapps/%{name}/WEB-INF/lib/$i %{buildroot}%{_javadir}/%{name}/$newFileName
done

# Symlink core libs
pushd %{buildroot}%{_datarootdir}/%{name}/libs
for i in thermostat-*.jar; do
  ln -s %{_datarootdir}/%{name}/libs/$i %{buildroot}%{_datadir}/tomcat/webapps/%{name}/WEB-INF/lib
done
popd
# Symlink plugin libs shipped with core
pushd %{buildroot}%{_datarootdir}/%{name}/plugins
for i in $(find -name 'thermostat-*.jar'); do
  ln -s %{_datarootdir}/%{name}/plugins/$i %{buildroot}%{_datadir}/tomcat/webapps/%{name}/WEB-INF/lib
done
popd
# Symlink other dependencies
pushd %{buildroot}%{_datadir}/tomcat/webapps/%{name}/WEB-INF/lib
ln -s %{_javadir}/apache-commons-collections.jar
ln -s %{_javadir}/apache-commons-beanutils.jar
ln -s %{_javadir}/apache-commons-logging.jar
ln -s %{_javadir}/apache-commons-io.jar
ln -s %{_javadir}/apache-commons-fileupload.jar
ln -s %{_javadir}/mongo.jar
ln -s %{_javadir}/google-gson.jar
ln -s %{_javadir}/apache-commons-codec.jar
popd

%pre
# add the thermostat user and group
%{_sbindir}/groupadd -r thermostat 2>/dev/null || :
%{_sbindir}/useradd -c "Thermostat" -g thermostat \
    -s /sbin/nologin -r -d %{_datarootdir}/%{name} thermostat 2>/dev/null || :

%post
# Install but don't activate
%systemd_post %{name}-agent.service
%systemd_post %{name}-storage.service
# Required for icon cache (i.e. Thermostat icon)
/bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :

%preun
%systemd_preun %{name}-agent.service
%systemd_preun %{name}-storage.service

%postun
# Required for icon cache (i.e. Thermostat icon)
if [ $1 -eq 0 ] ; then
    /bin/touch --no-create %{_datadir}/icons/hicolor &> /dev/null
    /usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi
%systemd_postun %{name}-agent.service
%systemd_postun %{name}-storage.service

%posttrans
# Required for icon cache (i.e. Thermostat icon)
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :

%files -f .mfiles
%doc COPYING
%doc LICENSE
%doc README
%config(noreplace) %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
# thermostat.desktop lives in /usr/share/applications
%{_datarootdir}/applications/%{name}.desktop
# thermostat icon
%{_datarootdir}/icons/hicolor/scalable/apps/%{name}.svg
%{_datarootdir}/%{name}
%{_libdir}/%{name}
%{_jnidir}/thermostat-*.jar
%{_bindir}/thermostat
%{_unitdir}/%{name}-storage.service
%{_unitdir}/%{name}-agent.service
# To these directories get written to when thermostat storage/agent
# run as systemd services
%attr(0770,thermostat,root) %dir %{system_datadir}
%attr(0770,thermostat,root) %dir %{system_datadir}/db
%attr(0770,thermostat,root) %dir %{system_cachedir}
%attr(0770,thermostat,root) %dir %{system_logdir}
%attr(0770,thermostat,root) %dir %{system_logdir}/storage
%attr(0770,thermostat,root) %dir %{system_statedir}/storage
%attr(0770,thermostat,root) %dir %{system_statedir}/agent

%files javadoc -f .mfiles-javadoc
%doc LICENSE
%doc COPYING

%files webapp -f .mfiles-webapp
%{_datadir}/tomcat/webapps/%{name}

%changelog
* Fri May 31 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.9.2-3
- Add thermostat SVG icon.
- Add systemd requires.

* Wed May 29 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.9.2-2
- Fix warning on uninstall.

* Fri May 24 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.9.2-1
- Update to upstream 0.9.2 release.
- With this update, storage/agent systemd services work in
  permissive mode.

* Wed May 22 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.9.0-1
- Update to upstream 0.9.0 release.
- Remove thermostat-client script.
- Fixes RHBZ#966892.

* Tue May 21 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.8.0-0.1.20130521hg97e66ed2e4ae
- Update to 0.8.0 pre-release.
- Install systemd unit files.

* Tue May 21 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-18
- Move require of servlet API to webapp sub-package.

* Mon May 20 2013 Omair Majid <omajid@redhat.com> 0.6.0-17
- COPYING and LICENSE should be included in all packages
- javadoc subpackage should be noarch

* Fri May 17 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-17
- Finish move to new-style mvn packaging.

* Fri May 17 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-16
- More xmvn + proper pom installation packaging progress.

* Fri May 17 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-15
- Require xmvn >= 0.4.2-1.1 in order to be able to skip installation
  of the web archive module.
- More work towards new-style packaging.

* Thu May 16 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-14
- More fixes using pom macros.
- Experiment with new-style packaging. Hit a road-block. Need a
  web archive installer which xmvn doesn't support :(

* Thu May 16 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-13
- Remove one more patch which can be replaced by pom macros.

* Fri Mar 15 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-12
- Remove plugins we don't need via pom macros.
- Add missing BR maven-javadoc-plugin.

* Fri Mar 15 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-11
- Fix webapp so as to allow symlinking deps.
- Add default users for webstorage.

* Fri Mar 15 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-10
- Fixup web.xml in thermostat-webapp.

* Thu Mar 14 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-9
- Fix thermostat-webapp so as to include web-server.jar

* Thu Mar 14 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-8
- Make disable_webservice_cmd.patch smaller (use pom macros instead).
- Remove unwanted files in /usr/share/thermostat which are generated by
  maven.
- Put all config files in /etc and symlink from appropriate places.

* Thu Mar 14 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-7
- Use pom macros instead of patches.

* Wed Mar 13 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-6
- Add webapp subpackage.

* Wed Mar 13 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-5
- Fix NPE on help.
- Fix bundle resolution errors for heap analysis commands.

* Tue Mar 12 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-4
- Fix bundle-loading patch so that all commands depending on
  httpcomponents-*.jars also start httpmime.

* Tue Mar 12 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-3
- Update init-layout-patch (was missing plugins symlink).
- Fix OSGi filter syntax (prevented thermostat gui from booting).

* Mon Mar 11 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.6.0-2
- Disable webservice command.
- Do a tomcat-only build.
- Work around jline2 jar not being there (see RHBZ#919640).

* Fri Mar 8 2013 Jon VanAlten <jon.vanalten@redhat.com> - 0.6.0-1
- Update to upstream 0.6.0 release.
- Also fix RHBZ 914544 (ftbfs)

* Fri Feb 15 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.0-0.28.20121123hgd6145521e208
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 0.5.0-0.27.20121123hgd6145521e208
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Mon Jan 7 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.5.0-0.26.20121123hgd6145521e208
- Remove felix-osgi-compendium BR/R since we don't use it (yet).

* Mon Jan 7 2013 Severin Gehwolf <sgehwolf@redhat.com> 0.5.0-0.25.20121123hgd6145521e208
- Fix for RHBZ 891840 (NoSuchMethodError on boot).

* Thu Dec 20 2012 Severin Gehwolf <sgehwolf@redhat.com> 0.5.0-0.24.20121123hgd6145521e208
- Fix broken symlinks in %{_jnidir}. See RHBZ#889187.

* Wed Dec 19 2012 Stanislav Ochotnicky <sochotnicky@redhat.com> - 0.5.0-0.23.20121123hgd6145521e208
- revbump after jnidir change

* Fri Nov 23 2012 Severin Gehwolf <sgehwolf@redhat.com> 0.5.0-0.22.20121123hgd6145521e208
- Update to more recent snapshot.
- New BR maven-war-plugin.

* Fri Nov 23 2012 Severin Gehwolf <sgehwolf@redhat.com> 0.5.0-0.21.20121121hg09c2918d8656
- Require better lucene which has the javax.management
  ImportPackage header.

* Thu Nov 22 2012 Severin Gehwolf <sgehwolf@redhat.com> 0.5.0-0.20.20121121hg09c2918d8656
- Build a first pre-release version of thermostat.
- Includes web layer.

* Thu Nov 15 2012 Severin Gehwolf <sgehwolf@redhat.com> 0.4.0-7
- Export JAVA_HOME before calling make.

* Thu Nov 15 2012 Severin Gehwolf <sgehwolf@redhat.com> 0.4.0-6
- Set JAVA_HOME via set_jvm.

* Wed Nov 14 2012 Severin Gehwolf <sgehwolf@redhat.com> 0.4.0-5
- Don't use maven-exec-plugin for compiling native bits.

* Mon Oct 22 2012 Severin Gehwolf <sgehwolf@redhat.com> 0.4.0-4
- Require >= jline2-2.5-7 since it has the import-package fix
  (see RHBZ#868291).

* Mon Oct 22 2012 Severin Gehwolf <sgehwolf@redhat.com> 0.4.0-3
- Fix RHBZ#868486
- Debug-infos were not properly generated.
- Do not override CFLAGS/LDFLAGS.

* Fri Oct 19 2012 Severin Gehwolf <sgehwolf@redhat.com> 0.4.0-2
- Fix jfreechart.jar symlink name.

* Tue Oct 16 2012 Severin Gehwolf <sgehwolf@redhat.com> 0.4.0-1
- Update to upstream 0.4 release.
- Starts dependencies as bundles.

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu Jul 19 2012 Severin Gehwolf <sgehwolf@redhat.com> 0.3-2
- Removed now obsolete patch (with jfreechart updated to 1.0.14)
- Added BR

* Thu Jul 12 2012 Omair Majid <omajid@redhat.com> - 0.3-1
- Update to upstream 0.3 release

* Sun May 06 2012 Omair Majid <omajid@redhat.com> - 0.2-0.20120506hg2140a7c81a4b
- Resolve RH813539
- Remove uneeded require on fusesource-pom
- Fix jar to use jline2 instead of jline

* Fri May 04 2012 Omair Majid <omajid@redhat.com> - 0.2-0.20120503hg2140a7c81a4b
- Update to pre-release upstream snapshot

* Mon Feb 13 2012 Omair Majid <omajid@redhat.com> - 0.1-1
- Updated description

* Tue Feb 07 2012 Omair Majid <omajid@redhat.com> - 0.1-1
- Intial package
